#pragma once

#include <set>
#include <string>
#include <memory>

#include "exploit.h"

class ExploitFactory
{
public:
    ExploitFactory();
    ~ExploitFactory();

    bool availableExploit(const std::string& p_exploit) const;

    const std::set<std::string>& getExploits() const;

    std::shared_ptr<Exploit> createExploit(const std::string& p_exploit) const;

private:

    const std::set<std::string> m_exploits;
};
